#!/bin/bash

set -u
set -e

exec 3<input.txt

OLDIFS=$IFS
IFS=","
read -u 3 -a data
IFS=$OLDIFS

base_dir=$(dirname $(readlink -f $BASH_SOURCE))
. computer.sh
. robot.sh

coproc computer (run_program data)

reset_robot
set_robot_start_on_white 1

check_pid=$computer_PID

while ( kill -0 $check_pid > /dev/null 2>&1 ); do
    get_robot_paint_colour >&${computer[1]}
    read -u ${computer[0]} direction
    read -u ${computer[0]} colour
    do_robot_paint_and_move $direction $colour
    sleep 0.1
done

# just incase the spinner is still about
echo -n $'\r'"                "$'\r'

echo "Part 2:"
draw_panel
